%define version 2.0
%define release 2mdk

Summary:	Stack Overflow protection
Name:		libsafe
Version:	%{version}
Release:	%{release}
Source:		%{name}-%{version}.tar.bz2
Copyright:	LGPL
Group:		System/Libraries
BuildRoot:	%{_tmppath}/libsafe
ExcludeArch: alpha, ppc, sparc, sparc64

%description
The libsafe library is designed to overwrite dangerous
library C function like strcpy / snprintf and perform
bound checking on the destination buffer address in order
to detect an eventual Stack Overflow attempt.

The libsafe library protects a process against the exploitation of buffer
overflow vulnerabilities in process stacks. Libsafe works with any
existing pre-compiled executable and can be used transparently, even on a
system-wide basis. The method intercepts all calls to library functions
that are known to be vulnerable. A substitute version of the corresponding
function implements the original functionality, but in a manner that
ensures that any buffer overflows are contained within the current stack
frame. Libsafe has been shown to detect several known attacks and can
potentially prevent yet unknown attacks. Experiments indicate that the
performance overhead of libsafe is negligible.

%prep
%setup -q

%build
# Do not use the Mandrake compilation flags,
# this library must not be compiled without any optimizations flags...
make

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
#problem with ldconfig in makefile cannot make install without patch
#make install LIBDIR=$RPM_BUILD_ROOT/lib LIBDIR=$RPM_BUILD_ROOT/%{_mandir} 


install -d $RPM_BUILD_ROOT/%{_mandir}/man8
install -m 644 doc/libsafe.8 $RPM_BUILD_ROOT%{_mandir}/man8
install -d $RPM_BUILD_ROOT/lib
install -m 644 src/libsafe.so.%{version} $RPM_BUILD_ROOT/lib
cd $RPM_BUILD_ROOT/lib
ln -s libsafe.so.%{version} libsafe.so.`echo %{version} | cut -d. -f1`


%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc doc/* exploits
/lib/*
%{_mandir}/*/*

%pre
if [ $1 = 0 -a -f %{_sysconfdir}/ld.so.preload ]; then 
		mv %{_sysconfdir}/ld.so.preload /tmp/ld.so.preload.old
		grep -v libsafe /tmp/ld.so.preload.old > %{_sysconfdir}/ld.so.preload
		rm -rf /tmp/ld.so.preload.old
fi

%post
/sbin/ldconfig
# For enable directly libsafe after install
touch %{_sysconfdir}/ld.so.preload
echo "/lib/libsafe.so.%{version}" >> %{_sysconfdir}/ld.so.preload


%preun
if [ $1 = 0 -a -f %{_sysconfdir}/ld.so.preload ]; then
		mv %{_sysconfdir}/ld.so.preload /tmp/ld.so.preload.old
		grep -v libsafe.so.%{version} /tmp/ld.so.preload.old > %{_sysconfdir}/ld.so.preload
		rm -rf /tmp/ld.so.preload.old
fi

%postun
LD_PRELOAD="" /sbin/ldconfig

%changelog
* Wed Apr  4 2001 Vincent Saugey <vince@mandrakesoft.com> 2.0-2mdk
- Remove reference on libsafe old version if upgrade 

* Mon Apr  2 2001 Vincent Saugey <vince@mandrakesoft.com> 2.0-1mdk
- Up to 2.0
- Adding more description
- use more maccro

* Thu Aug 31 2000 Yoann Vandoorselaere <yoann@mandrakesoft.com> 1.3-8mdk
- ExcludeArch: sparc, sparc64 
- use %{_mandir} %{_docdir}

* Fri Jul 14 2000 David BAUDENS <baudens@mandrakesoft.com> 1.3-7mdk
- ExludeArch: alpha (Geoffrey Lee <snailtalk@linux-mandrake.com>)

* Wed Jul 12 2000 David BAUDENS <baudens@mandrakesoft.com> 1.3-6mdk
- ExcludeArch: ppc (thanks to Yoann Vandoorselaere)

* Wed May 17 2000 Yoann Vandoorselaere <yoann@mandrakesoft.com> 1.3-5mdk
- libsafe in /lib instead of /usr/lib .

* Tue Apr 25 2000 Yoann Vandoorselaere <yoann@mandrakesoft.com> 1.3-4mdk
- fix a problem with getwd replacement

* Fri Apr 21 2000 Yoann Vandoorselaere <yoann@mandrakesoft.com> 1.3-3mdk
- util.c : __builtin_frame_address take a depth of 2.
- util.c : (fp <= stack_start).

* Fri Mar 31 2000 Yoann Vandoorselaere <yoann@mandrakesoft.com> 1.3-2mdk
- Fix group
- First libsafe package.
